/*
 *  file    : toko_clock.c
 *  auther  : Shinya Esu
 *  comment : פο
 *  version : $Id$
 */

#include <math.h>
#include <gtk/gtk.h>
#include <time.h>
#include "toko_clock.h"

#define HAND_LENGTH 80
int radius = HAND_LENGTH;
time_t before;
struct tm *now_tm;

/*
 * ˤκ褬ɬפȽꤹ
 */
gint CheckRepaintClock(void)
{
	time_t now;

	/* μ */
	time (&now);

	/* 郎ѹƤTRUE */
	if (difftime(before,now)) {
		now_tm = localtime(&now);
		before = now;
		return TRUE;
	} else {
		return FALSE;
	}
}

/*
 * ˤ
 *
 * data - widget to repaint
 */
gint RepaintClock(gpointer data, GdkPixmap *pixmap)
{
	GtkWidget*	drawing_area = (GtkWidget *) data;
	int midx, midy;
	int	nHour;
	float dRadians;
	GdkGC *gc;

	/* set GC */
	gc = drawing_area->style->fg_gc[GTK_STATE_NORMAL];

	/* 濴֤μ */
	midx = drawing_area->allocation.width / 2;
	midy = drawing_area->allocation.height / 2;

	/*
	 * ûˤ
	 */

	dRadians = (now_tm->tm_hour % 12) * 3.14 / 6.0 + 
			   (3.14 * now_tm->tm_min / 360.0);
	gdk_gc_set_line_attributes(gc,7,GDK_LINE_SOLID,GDK_CAP_ROUND,GDK_JOIN_ROUND);
	gdk_draw_line(pixmap, drawing_area->style->black_gc,
			   midx, midy,
			   midx + (int) (radius * 0.5 * sin (dRadians)),
			   midy - (int) (radius * 0.5 * cos (dRadians)));

	gdk_gc_set_line_attributes(gc,6,GDK_LINE_SOLID,GDK_CAP_ROUND,GDK_JOIN_ROUND);
	gdk_draw_line(pixmap, drawing_area->style->white_gc,
			   midx, midy,
			   midx + (int) (radius * 0.5 * sin (dRadians)),
			   midy - (int) (radius * 0.5 * cos (dRadians)));

	/* 
	 * Ĺˤ
	 */

	dRadians = (now_tm->tm_min * 3.14 / 30.0) +
			   (3.14 * now_tm->tm_sec / 1800.0);
	gdk_gc_set_line_attributes(gc,5,GDK_LINE_SOLID,GDK_CAP_ROUND,GDK_JOIN_ROUND);
	gdk_draw_line(pixmap, drawing_area->style->black_gc,
			   midx, midy,
			   midx+(int) (0.7 * radius * sin (dRadians)),
			   midy-(int) (0.7 * radius * cos (dRadians)));
	gdk_gc_set_line_attributes(gc,4,GDK_LINE_SOLID,GDK_CAP_ROUND,GDK_JOIN_ROUND);
	gdk_draw_line(pixmap, drawing_area->style->white_gc,
			   midx, midy,
			   midx+(int) (0.7 * radius * sin (dRadians)),
			   midy-(int) (0.7 * radius * cos (dRadians)));

	/* 
	 * ÿˤ
	 */
	dRadians = now_tm->tm_sec * 3.14 / 30.0;
	gdk_gc_set_line_attributes(gc,1,GDK_LINE_SOLID,GDK_CAP_ROUND,GDK_JOIN_ROUND);
	gdk_draw_line(pixmap, drawing_area->style->black_gc,
			   midx, midy,
			   midx + (0.9 * radius * sin (dRadians)),
			   midy - (0.9 * radius * cos (dRadians)));

	return (TRUE);
}
