/*
 *  file    : toko_mascot.c
 *  auther  : Shinya Esu
 *  comment : ޥåȤ
 *  version : $Id$
 */

#include <gtk/gtk.h>
#include <time.h>

#include "toko_types.h"
#include "toko_mascot.h"


/*
 * Pixmapɤ߹ߤȥޥåȤν
 */
void LoadPixmaps(GtkWidget *widget, typMascot *mascot, typSprite *sprites)
{

	int i = 0;

	while (sprites[i].xpm_data) {
		sprites[i].pixmap = gdk_pixmap_create_from_xpm_d(
						   widget->window,
						   &sprites[i].mask,
						   NULL,
						   sprites[i].xpm_data);
		i++;
	}

	GetWidthHeight(sprites[0].xpm_data, &mascot->width, &mascot->height);

	mascot->seq = 0;
	mascot->nSequences = i;
	mascot->sprites = sprites;
	mascot->wait=sprites[0].wait;
}


/*
 * 褬ɬפΥå
 */
gint CheckRepaintMascot(typMascot *mascot)
{
	if (mascot->wait<=0) {
		mascot->seq++;
		if (mascot->seq >= mascot->nSequences) {
			mascot->seq = 0;
		}
		mascot->wait=mascot->sprites[mascot->seq].wait;
		return TRUE;
	}
	else {
		mascot->wait--;
		return FALSE;
	}
}

/*
 * ޥåȤ
 *
 */
gint DrawMascot(gpointer data, GdkPixmap *pixmap, typMascot *mascot)
{
	GtkWidget*	drawing_area = (GtkWidget *) data;
	GdkGC *gc;

	gc = drawing_area->style->fg_gc[GTK_STATE_NORMAL];
	gdk_gc_set_clip_mask(gc, mascot->sprites[mascot->seq].mask);
	gdk_gc_set_clip_origin(gc, mascot->x, mascot->y);
	gdk_draw_pixmap(pixmap,
		  drawing_area->style->fg_gc[GTK_STATE_NORMAL],
		  mascot->sprites[mascot->seq].pixmap,
		  0, 0,
		  mascot->x, mascot->y,
		  mascot->width, mascot->height);
	gdk_gc_set_clip_mask(gc, NULL);
}


/*
 * xpmǡȹ⤵
 *
 */
void GetWidthHeight(gchar **xpm, int *width, int *height)
{
	
	sscanf(xpm [0], "%d %d", width, height);
}

